package com.example.photomemoriesgenerator;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.view.View;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ImageDecoder;
import android.graphics.Path;
import android.media.ExifInterface;
import android.media.FaceDetector;
import android.media.Image;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.DocumentsContract;
import android.provider.MediaStore;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

//import android.support.v7.app.AppCompatActivity;
import androidx.appcompat.app.AppCompatActivity;
import androidx.loader.content.CursorLoader;

public class settings extends AppCompatActivity {
    public final String ME = "ACTIVITY_SECOND";
    private Intent myIntent;
    ArrayList<photo> parray = MainActivity.parray;
    public static ArrayList<photo> actual = new ArrayList<>();
    int fileCount;
    int type = 1;
    int mn = 15;
    EditText sd;
    EditText sm;
    EditText sy;
    EditText ed;
    EditText em;
    EditText ey;
    EditText maxnum;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.settings);
        Log.i("here", "in settings");
        sd = findViewById(R.id.sd);
        sm = findViewById(R.id.sm);
        sy = findViewById(R.id.sy);
        ed = findViewById(R.id.ed);
        em = findViewById(R.id.em);
        ey = findViewById(R.id.ey);
        maxnum = findViewById(R.id.maxnum);
        fileCount = parray.size();
        sy.setHint("Start Year");
        Log.i("here", fileCount+" ");
        ed.setHint("End Day");
        em.setHint("End Month");
        ey.setHint("End Year");
        sd.setHint("Start Day");
        sm.setHint("Start Month");
        maxnum.setHint("Maximum Number of Photos");
        RadioButton people = findViewById(R.id.people);
        //RadioButton location = findViewById(R.id.locations);
        RadioButton date = findViewById(R.id.date);
        RadioGroup rb = (RadioGroup) findViewById(R.id.choices);
        rb.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            public void onCheckedChanged(RadioGroup arg0, int id) {//check to see which button is clicked
                switch (id) {
                    case R.id.people:
                        Log.i("here", "people");
                        type = 1;
                        break;
                    case R.id.date:
                        Log.i("here", "date");
                        type = 3;
                        break;
                    default:
                        Log.i("here", "Huh?");
                        break;
                }


            }
            });
    }

    public void CreateAlbum(View v) {//go through array of photos and see what matches the characteristics that the user wants
        if(TextUtils.isEmpty(maxnum.getText().toString()))//default of 15 photos
        {
            mn = 15;
        }
        else {
            mn = Integer.valueOf(maxnum.getText().toString());//get number from edittext
        }
        Log.i("here", "max"+mn);
        Log.i("here", maxnum.getText().toString());
        if(type ==1)//if people clicked
        {
            Log.i("here", "in if");
                for(int i = 0; i<fileCount; i++)
                {
                    Log.i("here", "in for");
                    if(parray.get(i).GetFaceDetection())//check to see if photo has faces
                    {
                        Log.i("here", "checked for face");
                        if(actual.size()<mn)//if album not at max
                            actual.add(parray.get(i));//add to album
                        else
                            break;

                    }

                }
                sortarray(actual);//sort array by date
            for(int i=0; i<actual.size(); i++)
            {
                Log.i("here", "actual times"+ actual.get(i).GetDateTime());
            }
                if(actual.get(1).GetFaceDetection())
                    Log.i("hello", "why?????");
        }
        if(type==3)//if date clicked
        {
           String stm;
            if(TextUtils.isEmpty(sm.getText().toString()))//if no month make it 01
            {
                stm = "01";
            }
            else
               stm = sm.getText().toString();//get month from edittext
            if(stm.length()==1)//make sure month is correct length
                stm = "0"+stm;
            String std;
            if(TextUtils.isEmpty(sd.getText().toString()))//if no day make it 01
            {
                std = "01";
            }
            else
                std = sd.getText().toString();//get day from edittext
            if(std.length()==1)//make sure day is correct length
                std = "0"+std;
            String sty;
            if(TextUtils.isEmpty(sy.getText().toString()))//if no year make it 2000
            {
                sty = "2000";
            }
            else
                sty = sy.getText().toString();//get edittext
            String endm;
            if(TextUtils.isEmpty(em.getText().toString()))//default month 04
            {
                endm = "04";
            }
            else
                endm = em.getText().toString();
            if(endm.length()==1)
                endm = "0"+endm;
            String endd;
            if(TextUtils.isEmpty(ed.getText().toString()))//default day 30
            {
                endd = "30";
            }
            else
                endd = ed.getText().toString();
            if(endd.length()==1)
                endd = "0"+endd;
            String endy;
            if(TextUtils.isEmpty(ey.getText().toString()))//default year 2022
            {
                endy = "2022";
            }
            else
                endy = ey.getText().toString();

            int s = Integer.valueOf(sty+stm +std);
            int e = Integer.valueOf(endy+endm+endd);


            for(int i=0; i<fileCount; i++) {
                CheckForDateTime(parray.get(i),s, e, actual);

            }
            sortarray(actual);
            for(int i=0; i<actual.size(); i++)
            {
                Log.i("here", "actual times"+ actual.get(i).GetDateTime());
            }

        }
        myIntent=new Intent(this, ShowAlbum.class);//go to show album page

        this.startActivity(myIntent);
    }
    void CheckForDateTime(photo p, int s, int e, ArrayList<photo> a)//use the start and end dates to figure out if the photos date is in that range
    //stored as year:month:day hour:minute:second
    {

        if (p.GetDateTime() == null) {
            Log.i("hello", p.GetDateTime() + " ");
        } else {
            Log.i("hello", p.GetDateTime() + " " + p.GetDateTime().substring(0, 4) + p.GetDateTime().substring(5, 7) + p.GetDateTime().substring(8, 10));//combine all numbers
            if ((Integer.valueOf(p.GetDateTime().substring(0, 4) + p.GetDateTime().substring(5, 7) + p.GetDateTime().substring(8, 10)) >= s)) {
                if ((Integer.valueOf(p.GetDateTime().substring(0, 4) + p.GetDateTime().substring(5, 7) + p.GetDateTime().substring(8, 10)) <= e)) {
                    if (a.size() < mn) {
                        a.add(p);
                        Log.i("here", s + " " + e + " " + (Integer.parseInt(p.GetDateTime().substring(0, 4) + p.GetDateTime().substring(5, 7) + p.GetDateTime().substring(8, 10))));
                    }
                }
            }


            return;
        }
    }
    public void sortarray(ArrayList<photo> a) {//go through array and sort by date
        int pos;
        photo p;
        photo q;
        for (int i = 0; i < a.size(); i++) {
            pos = i;
            for (int j = i + 1; j < a.size(); j++) {
                p = a.get(i);
                q = a.get(j);
                if(p.GetDateTime()==null)
                    pos = j;
                else if(q.GetDateTime()==null)//move photos with no date to the beginning
                    Collections.swap(a,i,j);
                else if (Integer.parseInt(p.GetDateTime().substring(0, 4) + p.GetDateTime().substring(5, 7) + p.GetDateTime().substring(8, 10)) > Integer.parseInt(q.GetDateTime().substring(0, 4) + q.GetDateTime().substring(5, 7) + q.GetDateTime().substring(8, 10))) {
                    //pos = j;
                    Collections.swap(a, i, j);//sort by date

                }
            }
        }
        return;
    }
    public void goBack(View v) {
        this.finish();
    }

    protected void onStart() {
        super.onStart();
        Log.i("hello", "onStart");
    }

    protected void onRestart() {
        super.onRestart();
        actual.clear();//clear the array when coming back to the activity
        Log.i("hello", "onRestart");
    }

    protected void onResume() {
        super.onResume();
        Log.i("hello", "onResume");
    }

    protected void onPause() {
        super.onPause();
        Log.i("hello", "onPause");
    }

    protected void onStop() {
        super.onStop();
        Log.i("hello", "onStop");
    }

    protected void onDestroy() {
        super.onDestroy();
        Log.i(ME, "onDestroy");
    }
}

